<template>
  <div :key="internalValue.length">
    <div v-for="(entry, index) in internalValue" :key="index">
      <b-input-group>
        <SearchSelect
          v-if="givenEntry.searchType"
          :id="givenEntry.predicate.value.replace(/[\/.#:]/g, '')"
          :application-profile="applicationProfile"
          :readonly="readonly"
          :type="givenEntry.searchType"
          :model-value="entry"
          @update:modelValue="fullUpdate(index, $event)"
        />

        <b-form-input
          v-if="!givenEntry.searchType"
          :placeholder="placeholder"
          :disabled="readonly"
          trim
          :model-value="entry"
          :state="!validList[index] ? false : undefined"
          @change="updateDefinition"
          @update:modelValue="updateProperty(index, $event)"
        />

        <template #append>
          <b-button
            v-if="givenEntry.searchType"
            :href="entry"
            target="_blank"
            variant="outline-secondary"
          >
            <i-bi-link45deg />
          </b-button>
          <b-form-select
            v-if="!givenEntry.searchType"
            :key="index"
            class="listSelectionType"
            :options="selectionOptions"
            :model-value="internalSelections[index]"
            :disabled="readonly"
            @update:modelValue="updateSelection(index, $event)"
          >
            <template #first>
              <b-form-select-option :value="''" disabled>{{
                $t("pleaseSelectOption")
              }}</b-form-select-option>
            </template>
          </b-form-select>
          <b-button
            class="listRemoveButton"
            :disabled="readonly"
            variant="outline-danger"
            @click="removeEntry(index)"
            ><i-bi-x
          /></b-button>
        </template>
      </b-input-group>
    </div>
    <b-button :disabled="readonly" class="mb-2 mt-2" @click="addEntry">{{
      $t("addEntry")
    }}</b-button>
  </div>
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import type { ShaclProperty } from "@/types/shape-properties";
import {
  dataTypes,
  defaultDataType,
  type SelectionType,
} from "@/util/shaclTypes";
import { isURI } from "@/util/uriCheck";
import factory from "rdf-ext";

const allSelections = [
  {
    text: "uri",
    value: "uri",
  },
  ...dataTypes,
];

import { defineComponent, type PropType } from "vue";

export default defineComponent({
  name: "PropertyList",
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    givenEntry: {
      required: true,
      type: Object as PropType<ShaclProperty>,
    },
    placeholder: {
      required: false,
      default: "Placeholder",
      type: String,
    },
    readonly: {
      required: true,
      type: Boolean,
    },
    selections: {
      required: true,
      type: Array as PropType<Array<SelectionType>>,
    },
    modelValue: {
      required: true,
      type: Array as PropType<Array<string>>,
    },
  },
  data() {
    return {
      internalValue: [] as string[],
      internalSelections: [] as string[],
      selectionOptions: allSelections,
    };
  },
  computed: {
    valid(): boolean {
      return this.validList.every((value) => value === true);
    },
    validList(): boolean[] {
      return this.internalValue.map(
        (value, index) =>
          this.internalSelections[index] !== "uri" || isURI(value),
      );
    },
  },
  watch: {
    value() {
      this.loadData();
    },
  },
  mounted() {
    this.loadData();
  },
  methods: {
    addEntry() {
      this.internalValue.push("");
      this.internalSelections.push(defaultDataType.value);
      this.input();
    },
    fullUpdate(index: number, entry: string) {
      this.updateProperty(index, entry);
      this.updateDefinition();
    },
    input() {
      if (this.valid) {
        this.$emit(
          "update:modelValue",
          this.internalValue.map((internal, index) =>
            this.internalSelections[index] === "uri"
              ? factory.namedNode(internal)
              : factory.literal(
                  internal,
                  factory.namedNode(this.internalSelections[index]),
                ),
          ),
        );
      }
    },
    loadData() {
      this.internalValue = this.modelValue;
      this.internalSelections = this.selections.map(
        (selection) => selection.value,
      );
      while (this.internalValue.length > this.internalSelections.length) {
        this.internalSelections.push(defaultDataType.value);
      }
    },
    removeEntry(index: number) {
      this.internalValue.splice(index, 1);
      this.internalSelections.splice(index, 1);
      this.input();
    },
    updateDefinition() {
      if (this.valid) {
        this.$emit("change");
      }
    },
    updateSelection(index: number, entry: string) {
      this.internalSelections = [...this.internalSelections];
      this.internalSelections[index] = entry;
      if (entry !== "uri" || isURI(this.internalValue[index])) {
        this.input();
      }
    },
    updateProperty(index: number, entry: string) {
      this.internalValue = [...this.internalValue];
      this.internalValue[index] = entry;
      if (this.internalSelections[index] !== "uri" || isURI(entry)) {
        this.input();
      }
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.listRemoveButton {
  height: calc(1.5em + 0.75rem + 2px);
}
.listSelectionType {
  width: 7rem;
}
</style>
